﻿using MVCSampleBrowser.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace AspGrid.Model
{
    public class OrderDataTable
    {
        public static List<EditableOrder> GetDataTable()
        {
            DataTable dt = new DataTable();
            DataColumn dc = new DataColumn("OrderID");
            dt.Columns.Add(dc);
            dc = new DataColumn("EmployeeID");
            dt.Columns.Add(dc);
            dc = new DataColumn("CustomerID");
            dt.Columns.Add(dc);
            dc = new DataColumn("Freight");
            dt.Columns.Add(dc);
            dt.Rows.Add(101, 2, "ALFKI", 32.09);
            dt.Rows.Add(102, 3, null, 15.2);
            dt.Rows.Add(103, 5, "VINET", 56.89);
            dt.Rows.Add(104, 7, "ANATOR", 23.2);
            IList result = dt.Select().ToList();
            var data = (from row in dt.AsEnumerable()
                        select new EditableOrder
                        {
                            OrderID = Convert.ToInt32(row["OrderID"]),
                            CustomerID = row["CustomerID"].ToString(),
                            EmployeeID = Convert.ToInt32(row["EmployeeID"]),
                            Freight = Convert.ToDecimal(row["Freight"]),

                        }).ToList();
            data.Add(new EditableOrder());
            return data;
        }
    }
}